/*
 * Copyright LWJGL. All rights reserved.
 * License terms: https://www.lwjgl.org/license
 * MACHINE GENERATED FILE, DO NOT EDIT
 */

/**
 * Contains bindings to the <a target="_blank" href="https://github.com/bkaradzic/bgfx">bgfx</a> library.
 * 
 * <p>The bgfx documentation can be found online <a target="_blank" href="https://bkaradzic.github.io/bgfx/">here</a>. The API reference is available
 * <a target="_blank" href="https://bkaradzic.github.io/bgfx/bgfx.html">here</a>.</p>
 * 
 * <p>The bgfx library is very customizable and can be tailored to specific needs. For this reason, the {@code lwjgl-bgfx} artifact does not include any
 * prebuilt native libraries.</p>
 * 
 * <p>To compile your own version, follow the <a target="_blank" href="https://bkaradzic.github.io/bgfx/build.html">build instructions</a> for Windows, Linux and MacOS.
 * Please ensure to use the {@code --with-shared-lib} configuration to create a shared library. Just copy the compiled library found in
 * {@code <bgfx>/.build/<platform>/bin/} to the classpath of your LWJGL application.</p>
 * 
 * <p>By default, lwjgl-bgfx searches for bgfx[32].dll (Windows), libbgfx.so (Linux) or libbgfx.dylib (MacOS). This can be customized by defining
 * {@code org.lwjgl.bgfx.libname}.</p>
 */
@org.lwjgl.system.NonnullDefault
package org.lwjgl.bgfx;

